<?
/*
Plugin RRDCleaner by Tut`
based on RRDcleanr.php by berger@hk-net.de ( 12/2004 )
(http://forums.cacti.net/viewtopic.php?t=5852)

Do NOT forget to add 
	$plugins[] = 'rrdclean';
in include/config.php  :)

*/

chdir('../../');
include("./include/auth.php");

$ds_actions = array(
	1 => "Delete",
	2 => "Backup",
	3 => "Archive"
);

$rra_path = $config["base_path"] . "/rra";

if (isset($_POST['drp_action'])) {
	do_rrd();
} else {
	list_rrd();
}

function list_rrd() {
	global $ds_actions, $rra_path, $colors;
	include_once("./include/top_header.php");
	html_start_box("<strong>RRD Cleaner</strong>", "98%", $colors["header"], "4", "center", "");
	html_header_checkbox(array("File name", "Last modified", "size"));
	$files_unused = get_files();
	$i = 0;
	if (sizeof($files_unused) > 0) {
		foreach($files_unused as $unused_file) {
			$filesize = filesize($rra_path . "/" . $unused_file);
			$sizes[] = $filesize;
			$filemtime = filemtime($rra_path . "/" . $unused_file);
			form_alternate_row_color($colors["form_alternate1"],$colors["form_alternate2"],$i);
			?>
			<td>
				<?php print $unused_file;?>
			</td>
			<td>
				<?php print date("F d Y H:i:s", $filemtime);?>
			</td>
			<td>
				<?php print round(($filesize/1024/1024), 2); ?> MB (<? print $filesize; ?>)
			</td>
			<td style="<?php print get_checkbox_style();?>" width="1%" align="right">
				<input type='checkbox' style='margin: 0px;' name='chk_<?php print $unused_file;?>' title="<?php print $unused_file;?>">
			</td>
			</tr>
			<?php
			$i++;
			} ?>
		<tr  bgcolor='#6d88ad'>
			<td class='textSubHeaderDark' colspan="2"><strong>Total</strong></td>
			<td class='textSubHeaderDark' colspan="2"><strong><? if($files_unused=="") {echo 0;} else {echo round(array_sum($sizes)/1024/1024, 2);} ?> MB</strong></td>
		</tr> <?php
		clearstatcache();
	}else{
		print "<tr><td><em>No unused rras</em></td></tr>\n";
	}
	html_end_box(false);
	draw_actions_dropdown($ds_actions);
	print "</form>\n";
	include_once("./include/bottom_footer.php");
}

function get_files(){
	global $rra_path;
	$result = mysql_query("select data_template_data.data_source_path 
				from data_template_rrd,data_template_data,graph_templates_item 
				where graph_templates_item.task_item_id=data_template_rrd.id 
				and data_template_rrd.local_data_id=data_template_data.local_data_id 
				and data_template_data.local_data_id > 0 
				group by data_template_data.data_source_path");
	while ($fld = mysql_fetch_row($result)) {
		$files_db[] = substr(strrchr($fld[0], "/"),1);

	}

	$handle = opendir($rra_path);
	while ($file = readdir ($handle)) {
		if (substr($file,-3) == "rrd") {
			if (!in_array($file, $files_db)) {
				$files_unused[] = $file;
			}
		}
	}
	closedir($handle);
	if (!isset($files_unused))  $files_unused="";
	return $files_unused;
}

function do_rrd(){
	global $rra_path, $colors;
	$files_unused = get_files();
	clearstatcache();
	if (($_POST['drp_action'] == "2") || ($_POST['drp_action'] == "3")){
		$rrd_move = db_fetch_cell("select value from settings where name ='rrd_move'",'');
		if ($rrd_move == '') {
			$rrd_move = $rra_path ."/unused";
		}
		if (!is_dir($rrd_move)) {
			mkdir($rrd_move);
		}
	}
	$text = '';
	include_once("./include/top_header.php");
	while (list($var,$val) = each($_POST)) {
		if (ereg("^chk_(.*)_rrd$", $var, $matches)) {
			$target = $matches[1] . ".rrd";
			if(in_array($target, $files_unused)) {
				switch ($_POST['drp_action']){
					case "1" :
					if (unlink($rra_path . "/" . $target)) {
						$text .= $target . " Deleted!<br>";
					}else{
						$text .= $target . " Error : unable to delete!<br>";
					}
					break;
					case "2" :
					if(copy($rra_path . "/" . $target, $rrd_move . "/" . $target)){
						$text .= $target . " Saved!<br>";
					}else{
						$text .= $target . " Error : unable to copy!<br>";
					}
					break;
					case "3" :
					if(rename($rra_path . "/" . $target, $rrd_move . "/" . $target)){
						$text .= $target . " Moved!<br>";
					}else{
						$text .= $target . " Error : unable to move!<br>";
					}
					break;
				}
			}else{
				print $target ."  : File not found\n";
			}
		}
	}
	if ($text != '') {
		html_start_box("", "98%", $colors["header"], "3", "center", "");
		form_alternate_row_color($colors["form_alternate1"],$colors["form_alternate2"], 0);
		print "<td>";
		print "$text</td></tr>";
		html_end_box(false);
		print '<br><br>';
	}
	list_rrd();
	include_once("./include/bottom_footer.php");
}

?>
