<?php

function plugin_init_rrdclean() {
	global $plugin_hooks;
	$plugin_hooks['config_arrays']['rrdclean'] = 'rrdclean_config_arrays';
	$plugin_hooks['draw_navigation_text']['rrdclean'] = 'rrdclean_draw_navigation_text';
	$plugin_hooks['config_settings']['rrdclean'] = 'rrdclean_config_settings';
}

function rrdclean_version () {
	return array('name' 	=> 'RRD Cleaner',
		'version'	=> '1.2');
}

function rrdclean_config_settings () {
	global $settings;
	$temp = array(
		"rrdclean_header" => array(
		"friendly_name" => "RRD Cleaner",
		"method" => "spacer",
		),
			"rrd_move" => array(
			"friendly_name" => "Backup directory",
			"description" => "This is the directory where rras are moved",
			"method" => "textbox",
			"max_length" => 255,
		),
	);
	if (isset($settings["path"]))
		$settings["path"] = array_merge($settings["path"], $temp);
	else
		$settings["path"] = $temp;
}

function rrdclean_config_arrays () {
	global $user_auth_realms, $user_auth_realm_filenames, $menu;
	$user_auth_realms[36]='Clean rra';
	$user_auth_realm_filenames['rrdcleaner.php'] = 36;
	$temp = $menu["Utilities"]['logout.php'];
	unset($menu["Utilities"]['logout.php']);
	$menu["Utilities"]['plugins/rrdclean/rrdcleaner.php'] = "RRD Cleaner";
	$menu["Utilities"]['logout.php'] = $temp;
}

function rrdclean_draw_navigation_text ($nav) {
	$nav["rrdcleaner.php:"] = array("title" => "RRD Cleaner", "mapping" => "index.php:", "url" => "rrdcleaner.php", "level" => "1");
	$nav["rrdcleaner.php:actions"] = array("title" => "Actions", "mapping" => "index.php:,rrdcleaner.php:", "url" => "rrdcleaner.php?action=actions", "level" => "2");
	return $nav;
}



?>
